#ifndef LINUX_SYSCALL_H
#define LINUX_SYSCALL_H

#define SYS_exit 1
#define SYS_fork 2
#define SYS_read 3
#define SYS_write 4
#define SYS_close 6
#define SYS_wait4 7
#define SYS_link 9
#define SYS_unlink 10
#define SYS_chdir 12
#define SYS_fchdir 13
#define SYS_mknod 14
#define SYS_chmod 15
#define SYS_chown 16
#define SYS_brk 17
#define SYS_lseek 19
#define SYS_getxpid 20
#define SYS_getpid SYS_getxpid
#define SYS_osf_mount 21
#define SYS_osf_umount 22
#define SYS_umount SYS_osf_umount
#define SYS_setuid 23
#define SYS_getxuid 24
#define SYS_getuid SYS_getxuid
#define SYS_ptrace 26
#define SYS_access 33
#define SYS_sync 36
#define SYS_kill 37
#define SYS_setpgid 39
#define SYS_dup 41
#define SYS_pipe 42
#define SYS_open 45
#define SYS_getxgid 47
#define SYS_getgid SYS_getxgid
#define SYS_osf_sigprocmask 48
#define SYS_sigprocmask SYS_osf_sigprocmask
#define SYS_ioctl 54
#define SYS_symlink 57
#define SYS_readlink 58
#define SYS_execve 59
#define SYS_chroot 61
#define SYS_umask 60
#define SYS_getpgrp 63
#define SYS_getpagesize 64
#define SYS_osf_vfork 66
#define SYS_newstat 67
#define SYS_stat SYS_newstat
#define SYS_newlstat 68
#define SYS_lstat SYS_newlstat
#define SYS_osf_mmap 71
#define SYS_mmap SYS_osf_mmap
#define SYS_munmap 73
#define SYS_mprotect 74
#define SYS_madvise 75
#define SYS_vhangup 76
#define SYS_getgroups 79
#define SYS_setgroups 80
#define SYS_setitimer 83
#define SYS_getitimer 86
#define SYS_gethostname 87
#define SYS_sethostname 88
#define SYS_getdtablesize 89
#define SYS_dup2 90
#define SYS_newfstat 91
#define SYS_fstat SYS_newfstat
#define SYS_fcntl 92
#define SYS_select 93
#define SYS_fsync 95
#define SYS_setpriority 96
#define SYS_socket 97
#define SYS_getpriority 100
#define SYS_sigreturn 103
#define SYS_bind 104
#define SYS_listen 106
#define SYS_sigsuspend 111
#define SYS_gettimeofday 116
#define SYS_getrusage 117
#define SYS_settimeofday 122
#define SYS_fchown 123
#define SYS_fchmod 124
#define SYS_setreuid 126
#define SYS_setregid 127
#define SYS_rename 128
#define SYS_truncate 129
#define SYS_ftruncate 130
#define SYS_setgid 132
#define SYS_mkdir 136
#define SYS_rmdir 137
#define SYS_utimes 138
#define SYS_getrlimit 144
#define SYS_setrlimit 145
#define SYS_setsid 147
#define SYS_sigaction 156
#define SYS_osf_getdirentries 159
#define SYS_getdirentries SYS_osf_getdirentries
#define SYS_osf_statfs 160
#define SYS_statfs SYS_osf_statfs
#define SYS_osf_fstatfs 161
#define SYS_fstatfs SYS_osf_fstatfs
#define SYS_osf_getdomainname 165
#define SYS_getdomainname SYS_osf_getdomainname
#define SYS_osf_swapon 199
#define SYS_swapon SYS_osf_swapon
#define SYS_osf_utsname 207
#define SYS_uname SYS_osf_utsname
#define SYS_getpgid 233
#define SYS_osf_usleep_thread 251
#define SYS_bdflush 300
#define SYS_sethae 301
#define SYS_mount 302
#define SYS_adjtimex 303
#define SYS_swapoff 304
#define SYS_getdents 305
#define SYS_reboot 55
#define SYS_setdomainname 166
#define SYS_sigpending 52
#define SYS_acct 51
#define SYS_accept 99
#define SYS_connect 98
#define SYS_getpeername 141
#define SYS_getsockname 150
#define SYS_getsockopt 118
#define SYS_recvfrom 125
#define SYS_send 101
#define SYS_recv 102
#define SYS_recvmsg 113
#define SYS_sendmsg 114
#define SYS_sendto 133
#define SYS_shutdown 134
#define SYS_socketpair 135
#define SYS_setsockopt 105

#define	SYS_msgctl 200
#define	SYS_msgget 201
#define	SYS_msgrcv 202
#define	SYS_msgsnd 203
#define	SYS_semctl 204
#define	SYS_semget 205
#define	SYS_semop 206
#define	SYS_shmat 209
#define	SYS_shmctl 210
#define	SYS_shmdt 211
#define	SYS_shmget 212
#endif
